(  HandTo.MUF    by Gyroplast                                                )
(                                                                            )
(  Enables you to hand objects to another player/zombie.                     )
(                                                                            )
(  This is supposed to be a global action.                                   )
(                                                                            )
(  To set it up, simply create an action called 'hand', link it to the prog, )
(  and you're all set.                                                       )
(                                                                            )
(  HAVE PHUN!                                                                )
(                                                                            )
lvar plname
: help
  "USAGE: hand <object> to <player>" .tell
  "Do not forget the ' to ' between the names!" .tell
;
: handover (d d --  )  (thing,player)
  over name over name
  swap
  me @ name " hands " strcat swap strcat 
  " over to " strcat swap strcat ". " strcat 
  .otell
  dup name plname !
  swap dup name "You hand the " swap strcat " over to " strcat
  plname @ strcat "." strcat 
  .tell
  swap
  moveto
;
: main
  dup not if help exit then
  tolower " to " explode
  2 = not if help exit then
  match
  dup #-1 dbcmp if 
    "Err, no object with that name exists!" .tell exit 
  then
  dup #-2 dbcmp if 
    "I don't know which one you mean! Be more specific, please!" .tell exit 
  then
  dup thing? not if help exit then
  swap dup .pmatch
  dup #-1 dbcmp if
    pop dup match dup #-1 dbcmp if
      "Invalid player, try again." .tell exit
    then
  then
  dup location me @ location dbcmp not if 
    "You have to be in the same room like the recipient!" .tell exit 
  then
  dup "_hand/hand_ok" getpropstr "yes" stringcmp if 
    "Sorry, this player does not want to get any items!" .tell exit 
  then
  me @ "_hand/hand_ok" getpropstr "yes" stringcmp if 
   "You cannot hand items! Set your _hand/hand_ok property." .tell exit 
  then
  swap pop
  handover
;

