(
  GDM.MUF    by Gyroplast  01/03/98
 
  Global Destination Manager - Allows you to easily create,
  delete and maintain global teleport destinations.
 
  Needed M-Level: 3
  
  Setup is easy as pie, just link an action to it, and
  make sure the $def below holds the correct dbref# of your tport.muf.
  Have phun.
)
$def progdb #904     (<--- Change this to the dbref of your tport.muf)
$def ver "v1.01"
lvar cat
lvar temp
lvar temp2
lvar global
lvar dest
lvar descrip
: lines
  BEGIN
   dup while
   " " .tell
   1 -
  REPEAT
  pop
;
: pad
  swap "                                                            " strcat swap strcut pop
;
: addglobal
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat "_cat/" swap strcat 
  "1"
  BEGIN
   over over strcat
   progdb swap getpropstr
   dup not if pop break else
    pop atoi 1 + intostr
   then
  REPEAT
  strcat progdb swap
  "Enter name of global. '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = over not OR if pop pop pop exit then
  global !
  "Enter description. '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = over not OR if pop pop pop exit then
  descrip !
  BEGIN
  "Enter destinations dbref. '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = over not OR if pop pop pop exit then
  "" "#" SUBST atoi dup not over dbref dup ok? if room? not else pop 1 then OR
  if pop "Invalid dbref."  .tell " " .tell
  else dest ! break then
  REPEAT
  global @ 0 ADDPROP
  progdb "_name/" global @ strcat descrip @ 0 ADDPROP
  progdb "loc/" global @ strcat dest @ intostr 0 ADDPROP
  progdb "_cat/" progdb "_cats#/" cat @ strcat getpropstr "#" strcat strcat "1" 0 ADDPROP
;
: delglobal
  dup
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat swap strcat
  progdb swap "_cat/" swap strcat over over getpropstr
  progdb over "loc/" swap strcat remove_prop
  progdb swap "_name/" swap strcat remove_prop
  remove_prop
  progdb "_cat/"
  progdb "_cats#/" cat @ strcat getpropstr
  strcat "#" strcat propdir? not if
  progdb "_cat/"
  progdb "_cats#/" cat @ strcat getpropstr
  strcat "#" strcat remove_prop
  progdb "_cats#/" cat @ strcat remove_prop 
  progdb "_cats#" getpropstr atoi 1 - 
  dup not if pop progdb "_cats#" remove_prop 
  else intostr
  progdb swap "_cats#" swap 0 ADDPROP 
  "_cats#/" cat @
  BEGIN
   over over atoi 1 + intostr strcat progdb swap getpropstr
   dup while
   progdb swap 4 pick 4 pick strcat swap 0 ADDPROP
   atoi 1 + intostr
   over over strcat progdb swap remove_prop
  REPEAT
  pop pop pop
  then pop
  else
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat "_cat/" swap strcat swap
  BEGIN
   over over atoi 1 + intostr strcat progdb swap getpropstr
   dup while
   progdb swap 4 pick 4 pick strcat swap 0 ADDPROP
   atoi 1 + intostr
   over over strcat progdb swap remove_prop
  REPEAT
  pop pop pop
  then
  "Deleted." .tell
;
: editglobal
  temp !
  5 lines
  "Global name : "
  progdb "_cat/"
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat temp @ strcat strcat getpropstr
  dup temp2 ! dup global ! strcat .tell
  "Enter new name, space to keep this one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop "Aborted." .tell exit then
  dup if global ! else pop then
  1 lines
  "Description : "
  progdb "_name/" temp2 @ strcat getpropstr
  dup descrip ! strcat .tell
  "Enter new description, space to keep this one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop "Aborted." .tell exit then
  dup if descrip ! else pop then
  BEGIN
  1 lines
  "Destination : "
  progdb "loc/" temp2 @ strcat getpropstr
  dup dest ! dup atoi dbref name swap " (#" swap strcat ")" strcat strcat
  strcat .tell
  "Enter new destination, space to keep this one, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop "Aborted." .tell exit then
  dup if
   "" "#" SUBST
   atoi dup if 
    dbref
    dup ok? if 
     dup room? not 
    else
     1 
    then
    if 
     pop "Invalid dbref." .tell continue 
    else
     intostr "" "#" subst dest ! break 
    then
   else
    pop "Invalid dbref." .tell continue
   then
  else pop break then
  REPEAT
  progdb "loc/" temp2 @ strcat remove_prop
  progdb "_name/" temp2 @ strcat remove_prop
  progdb "_cat/"
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat strcat temp @ strcat global @ 0 ADDPROP
  progdb "_name/" global @ strcat descrip @ 0 ADDPROP
  progdb "loc/" global @ strcat dest @ 0 ADDPROP
  "Information changed." .tell
;
: addcat
  1 lines
  "Category does not exist. Create it? (y/n)" .tell
  READ STRIP
  1 strcut pop
  "y" stringcmp if exit then
  progdb swap
  "_cats#/" progdb "_cats#" getpropstr atoi 1 + intostr strcat
  swap 0 ADDPROP
  progdb "_cats#" over over getpropstr atoi 1 + intostr 0 ADDPROP
  "Category added." .tell
;
: editcat
  cat !
  BEGIN
  5 lines
  " #  | Global      | Description                      | Destination" .tell
  "----+-------------+----------------------------------+---------------------" .tell
  "1" temp !
  BEGIN
   progdb "_cats#/" cat @ strcat getpropstr
   "_cat/" swap strcat "#/" strcat
   "" swap 
   temp @
   " " over strcat 3 pad " | " strcat 3 put
   over over strcat progdb swap
   getpropstr
   dup not if pop pop pop pop break then
   4 pick swap 12 pad strcat "| " strcat 3 put
   strcat progdb swap getpropstr
   progdb over "_name/" swap strcat getpropstr
   3 pick swap 33 pad "| " strcat strcat 2 put
   progdb swap "loc/" swap strcat getpropstr " (#" over strcat ")" strcat swap
   atoi dbref 
   dup room? if name else pop "RECYCLED" then
   20 pad swap strcat
   strcat
   .tell
   temp @
   atoi 1 + intostr temp !
  REPEAT
  2 lines
  "Type 'n' to create a new global, a number to delete or edit, or '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop "Aborted." .tell break then
  dup "n" stringpfx 1 = if pop addglobal continue then
  atoi dup not if pop continue else intostr then
  progdb "_cats#/" cat @ strcat getpropstr
  "#/" strcat over strcat "_cat/" swap strcat progdb swap getpropstr
  not if pop continue else
  BEGIN
  "Do you want to <d>elete or <e>dit this global? '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop pop break then
  dup "d" stringpfx 1 = if pop delglobal break then
  dup "e" stringpfx 1 = if pop editglobal break then
  pop
  REPEAT
  then
  REPEAT
  
;
: main
  me @ "W" flag? not if "Sorry, only wizards may use this program." .tell exit then
  pop
  BEGIN
  2 lines
  "GDM " ver strcat "     by Gyroplast" strcat .tell
  "--------------------------" .tell
  2 lines
  "Current teleport categories:" .tell
  progdb "_cats#" getpropstr atoi
  dup not if
   "<No categories set>" .tell
  else
   1
   BEGIN
     over over < if pop break then
     progdb over "_cats#/" swap intostr strcat getpropstr
     over intostr ".  " strcat swap strcat
     .tell
     1 +
   REPEAT
  then
  pop
  1 lines
  "Type the number of a category to edit, or a new name to create another one."
  .tell
  "Type '.' to abort." .tell
  READ STRIP
  dup "." stringpfx 1 = if pop "Aborted." .tell exit then
  dup "~" stringpfx 1 = over "*" stringpfx 1 = OR
  over "!" stringpfx 1 = OR over "#" stringpfx 1 = OR
  if
   pop "Ehr.. no. Please use only alphanumerical characters here." .tell
  continue then
  dup atoi not if addcat else
  progdb over "_cats#/" swap strcat getpropstr not if pop continue then
  editcat then
  REPEAT
;

