(
   medical-tricorder.muf     by Gyroplast  01/03/98
 
   A program to use with combat3.muf, giving some information
   on the scanned fur, and providing an efficient healing action.
 
   SETUP:
     1. @create the tricorder object.
     2. @action scan;hypo=<tricorder object>
     3. @link scan;hypo=<dbref of this program>
 
   After that, type
     scan <name>    to scan a fur, or
     hypo <name>    to heal that person.
 
   Change the $def below to the dbref of the object holding the
   combat data. {hp, maxhp, dex, etc.}
 
   Have Phun!
)
$def database #228   (<-- Change this!)
lvar dbnumber
lvar threat
lvar mythreat
: pad
  swap "                                                   " strcat swap strcut pop
;
: getcondition ( d --  )
  "_" swap name strcat dup database swap "/hp" strcat getpropstr dup atoi threat !
  dup not if pop 
   "         Health : Perfectly healthy." .tell
   "         Threat : NO" .tell exit
  then
  atoi swap dup database swap "/maxhp" strcat getpropstr
  atoi swap dup database swap "/dex" strcat getpropstr dup atoi threat @ + threat !
  swap dup database swap "/str" strcat getpropstr dup atoi threat @ + threat !
  swap database swap "/exp" strcat getpropstr dup atoi 10 / threat @ + threat !
  "     Experience : " swap strcat .tell
  "       Strength : " swap strcat .tell
  "      Dexterity : " swap strcat .tell
  over over intostr " HP" strcat " out of " swap strcat swap intostr swap strcat
  "         Health : " swap strcat .tell
  over 0 <= if pop pop "    The subject is dead." .tell else
  swap 100 * swap /
  dup 100 = if pop "                  The subject is perfectly healthy." .tell else
  dup 90 >= if pop "                  The subject is healthy." .tell else
  dup 75 >= if pop "                  The subject is slightly wounded." .tell else
  dup 40 >= if pop "                  The subject is wounded. Medical attention needed." .tell else
  dup 10 >= if pop "                  The subject is badly wounded, and needs immediate medical attention!" .tell else
  0 > if "                  Lifesigns are dropping rapidly! DEATH OF SUBJECT IS IMMINENT!" .tell then
  then then then then then then
  " " .tell
  "         Threat : "
  database "_" me @ name strcat "/hp" strcat getpropstr atoi mythreat !
  database "_" me @ name strcat "/dex" strcat getpropstr atoi mythreat @ + mythreat !
  database "_" me @ name strcat "/str" strcat getpropstr atoi mythreat @ + mythreat !
  database "_" me @ name strcat "/exp" strcat getpropstr atoi 10 / mythreat @ + mythreat !
  threat @ 10 + mythreat @ < if "Minimal" strcat .tell exit then
  threat @ 50 - mythreat @ >= if "RUN FOR YOUR LIFE!" strcat .tell else "Dangerous" strcat .tell then
;
: showscan  ( s --  )
  "Scanning " over strcat "..." strcat .tell
  me @ name " is running a medical scan over " strcat swap strcat "..." strcat .otell
  dbnumber @ me @ name " is scanning you!" strcat notify
  " " .tell
  "Results of medical scan:" .tell
  "------------------------" .tell
  "  Species   : " dbnumber @ "species" getpropstr dup not if pop "uncertain" then strcat .tell
  "  Gender    : " dbnumber @ "sex" getpropstr dup not if
   pop dbnumber @ "gender" getpropstr dup not if pop "uncertain" then then strcat .tell
  " " .tell
  "  Condition : " .tell
  dbnumber @ getcondition
;
: doheal
  "You grab your medical utensils, and treat " over strcat "'s injuries." strcat .tell
  " grabs %p medical utensils, and treats " over strcat "'s injuries." strcat me @ name swap
  strcat me @ swap pronoun_sub .otell
  database over "_" swap strcat "/maxhp" strcat getpropstr atoi dup
  10 / random 4 % +
  database "_" 5 pick strcat "/hp" strcat getpropstr atoi +
  over over < if
   pop
   dbnumber @ "You healed %o completely!"  pronoun_sub .tell
   dbnumber @ me @ name " healed %o completely!" strcat pronoun_sub .otell
   dbnumber @ me @ name " healed you!" strcat notify
  else
   swap pop
   dup database "_" dbnumber @ name strcat "/hp" strcat getpropstr atoi -
   "You restore " over intostr strcat " HP!" strcat .tell
   me @ name " restored " strcat swap intostr strcat " HP!" strcat .otell
   dbnumber @ me @ name " healed you!" strcat notify
  then
  intostr database
  rot "/hp" strcat "_" swap strcat rot 0 ADDPROP
;  
: main
  database me @ name "_" swap strcat "/skills/doctor" strcat getpropstr
  STRIP "yes" stringcmp if
   "Dammit, Jim! You're a rocket scientist, not a doctor!" .tell
   "You don't have a clue how to use that device!" .tell
   pop exit 
  then
  command @ "scan" stringcmp not if
   dup not if 
   pop
    "You wave aimlessly through the air with the scanner," .tell 
    "and finally have to say.. \"Yup, the air is dead, Jim.\"" .tell exit
   then
   match
   dup #-1 dbcmp if
    "Hmm.. this person is dead. Oh, not dead, just not here." .tell
    pop exit
   then
   dup #-2 dbcmp if
    "You are not quite sure who you want to scan," .tell
    "so you decide to think of a less ambiguous name next time." .tell
    pop exit
   then
   dup player? not if
    dup thing? over "Z" flag? AND not if
    "Things usually aren't alive. You should know that." .tell
    pop exit
   then then
   dup dbnumber !
   name
   showscan
  else
   dup not if 
   pop
    "You wave aimlessly through the air with the hypo," .tell 
    "desperately trying to find a person to cure." .tell exit
   then
   match
   dup #-1 dbcmp if
    "Hmm.. this person is dead. Oh, not dead, just not here." .tell
    pop exit
   then
   dup #-2 dbcmp if
    "You are not quite sure who you want to heal," .tell
    "so you decide to think of a less ambiguous name next time." .tell
    pop exit
   then
   dup player? not if
    "Things usually don't need any medical care. You should know that." .tell
    pop exit
   then
   dup dbnumber !
   name
   database over "_" swap strcat "/dex" strcat getpropstr not if
    "This person is perfectly healthy." .tell pop exit 
   then
   database over "_" swap strcat "/hp" strcat getpropstr
   over database swap "_" swap strcat "/maxhp" strcat getpropstr
   stringcmp not if
    "This person is perfectly healthy." .tell pop exit
   then
   doheal
  then
;

