( Jaffa's cmd-look )
 
( This program may be freely ported.  Please obtain the latest version
( from http://go.to/muf and notify the author as to where this program
( is ported to.  Thank you.
 
( Jaffa @ FM, FT, SPR, TimeScape, Tapestries, Fluff and other Mucks )
 
$def version prog "_version" getpropstr 
$def fake.muf-version "1.18"
 
$include $lib/look-install
$include $lib/multiname
$ifdef ansi-support
$ifdef __glowver
$def ansi_otell loc @ me @ rot ansi_notify_except
$else
$include $lib/ansi
$endif
$else
$undef colorized
$endif
$ifdef colorized
$include $lib/look-color
$endif
$ifdef neonet-support
$include $lib/neonet
$endif
$ifdef j-lib-puppet
$include $lib/puppet
$else
$def far_pname swap pop \name
$endif
$ifdef j-lib-fake>1.4
$def fake_object "$lib/fake" match "fake_object" call
$else
$undef j-lib-fake
$endif
$include $lib/lmgr
$ifdef path-support
$include $lib/path
$def path? #-6 dbcmp
$endif
  
( Required: this program [set M3]
(           look-call.muf [wiz-owned and set WLM3]
(           fake.muf [wiz-owned and set LSHM3
(                  OR set LM3 and see comments in fake.muf]
(           $lib/multiname
(           $lib/look-install
 
( Installation ( this section superceded by install program )
(   - set the fake object defines [here and in fake.muf]
(     I prefer the behaviour with both $defs commented out, YMMV
(   - link an action l;lo;loo;look;lookat;wl;wizlook to this program
(     the wl;wizlook aliases are only required if you want to support
(     the enhanced wizlook for Wizards [ignores S,Q,K flags; includes
(     rooms in contents; ignores locks - always executing the @succ]
 
( Optional extras
(   objecteditor.muf - set $def objecteditor to the name of the action
(                      linked to this program.  If you don't have any sort
(                      of fake object editor remove the $def completely
(   fsmell.muf - smell/taste/feel for fake objects.  It's much nicer if this
(                can be integrated with smell/taste/feel for real objects
(   $lib/fake - library of routines facilitating the writing of programs
(               which will work on both real and fake objects
 
( $def look-call #XXXXX (dbref of look-call.muf) (now handled by install script)
( $def fake.muf  #XXXXX (dbref of fake.muf)
 
( The following defines are best set on $lib/look-install, as e.g.
( @set $lib/look-install=_defs/filter-support:1 )
 
( $def filter-support 1 ( define to include support for look filters )
( $def look-long-support 1 ( define to support long descs on _/lde )
( $def no-K-support 1 ( define to exclude support for K flag on rooms )
( $def no-Q-support 1 ( define to exclude support for Q flag on rooms )
( $def no-auto-notify 1 ( define to disable automatic look notify )
( $def Author-support 1 ( follow the GlowMuck usage of the A flag on players )
( $def colorized 1 ( look messages output in color )
( $def path-support 1 ( support GlowMuck @paths - needs $lib/path )
 
$ifndef no-auto-notify
$def auto-notify 1
$endif
 
( For auto-notify, set _defs/notify-prop on $lib/look-install to be the
( prop containing the player's look notify message.  This needs to be
( "quoted", and for security reasons it should be an _prop
( e.g. @set $lib/look-install=_defs/notify-prop:"_desc_notify_looked"
( If this is not set, the default "_prefs/look/notify" will be used. )
 
$ifdef auto-notify
 $ifndef notify-prop
  $def notify-prop "_prefs/look/notify"
 $endif
 $ifdef look-long-support
  $ifndef notify-long-prop
   $def notify-long-prop notify-prop "-long" strcat
  $endif
 $endif
$endif
 
( To set a default @succ message for rooms without one [e.g. for an
( automatic obvious exits listing], set this on _defs/default-succ,
( e.g. @set $lib/look-install=_defs/default-succ:"{obvexits}"
 
( compatibility defines for fake objects )
( these are now in $lib/look-install - do not modify the code here )
( $def fake-show-default-is-no 1
  ( uncomment above line if fake objects are NOT visible by default
  ( with $def    -- fake objects don't show in Contents unless the 'show'
  (                 field is defined and doesn't evaluate to 'no'
  ( without $def -- fake objects show in Contents unless the 'show'
  (                 field is defined and evaluates to 'no' )
( $def fake-dark-objs-are-visible 1
  ( uncomment above line if invisible fake objects can be seen by look
  ( with $def    -- invisible [not shown in Contents] fake objects
  (                 function as looktraps similarly to _details
  ( without $def -- invisible fake objects cannot be 'look'ed at
  (                 (this is useful if you want to create objects
  (                 which are only visible to certain people, or
  (                 which only exist in certain morphs; e.g. for an
  (                 object visible only to foxes, set the 'show' field
  (                 to '{if:{instr:{prop:species,me},fox},yes,no}' and
  (                 the desc to e.g. "Congratulations on being a fox!" :)
 
$def fake-dark-default $ifdef fake-show-default-is-no 1 $else 0 $endif
( test to allow wizlook -- set _defs/look-wiz-check to change )
$def me-wiz? $ifdef look-wiz-check look-wiz-check $else me @ "W" flag? $endif
 
$def prog-wiz? prog $ifdef __glowver mlevel 3 > $else "W" flag? $endif
$def inside? over \location over dbcmp rot rot dbcmp or
$def person? dup thing? if "Z" flag? else player? then
$def streq stringcmp not
$def isplit over over instring dup if rot swap 1 - strcut rot strlen strcut swap pop else pop pop "" then ( case-insensitive split macro )
$def showdark " [Dark]" $ifdef colorized "refs" add-color $endif strcat
$def wizlook? cmd-wizlook @ if me @ "_prefs/wizlook/" rot strcat getpropstr dup if "n*" smatch then then not
 
$define me-controls
   sticky? @ s-fake > if pop 0 else
$ifdef Author-support
    me @ over controls swap owner "A" flag? or
$else
    me @ swap controls
$endif
   then
$enddef
 
$ifdef masquerade
$def masquerade-room? "_prefs/look/masquerade" envpropstr swap pop
$endif
 
( pass .tells through ANSI and filters if needed )
$def .atell $ifdef ansi-support me @ swap ansi_notify $else .tell $endif
$def .ftell $ifdef filter-support filter @ if filter-tell pop else .atell then $else .atell $endif
$def .ntell sublook @ if sublook-tell else .ftell then
$def .iftell dup if .ntell else pop then
$def .aotell $ifdef ansi-support ansi_otell $else .otell $endif
$def .notell dup if me @ \name " " strcat swap strcat .aotell else pop then
 
( defines for _details and fake objects )
var fake-dbref
var fake-name
var fake-dark?
$def details? #-5 dbcmp
$def details-prop fake-dbref @ "_details/" fake-name @ strcat
$def fake? dup #-4 dbcmp swap details? or
$def showfake " [Fake]" $ifdef colorized "refs" add-color $endif strcat
$def showdarkfake " [Hidden]" strcat
$def fake-prop fake-dbref @ "_fake/" fake-name @ strcat "/" strcat rot strcat
$def name dup fake? if pop fake-name @ multi-1name else \name then
$def owner dup fake? if pop fake-dbref @ then \owner
$def location dup fake? if pop fake-dbref @ else \location then
$define fake-is-dark?
   "show" fake-prop "look" 1 parseprop
   dup if "n*" smatch else pop fake-dark-default then
$enddef
$def my-fake? fake-dbref @ me-controls
 
( defines for contents-match )
$def cm-exact 2
$def cm-partial 1
$def cm-none 0
 
( messages )
$include $lib/look-messages
 
$def get-notify-owner-msg dup "_prefs/object-notify" getpropstr dup not if pop notify-owner-msg then
$def get-notify-fake-msg dup "_prefs/fake-notify" getpropstr dup not if pop get-notify-owner-msg then
$def get-notify-room-msg dup "_prefs/room-notify" getpropstr dup not if pop notify-room-msg then
  
$def error-tell $ifdef colorized "error" add-color $endif .atell
$def msg-tell $ifdef colorized "message" add-color $endif .atell
 
$define look-version
   "cmd-look v" version strcat
( ifdef neonet-support                  )
(   cmd-neolook @ if "-neo" strcat then ) ( breaks with filter-support )
( endif                                 )
$enddef
$def help-title look-version " -- by Jaffa Tamarin" strcat msg-tell " " .tell
 
( silent modes )
$def s-noisy  0 ( noisy mode ) 
$def s-fake   1 ( don't show Hidden fakes )
$def s-quiet  2 ( quiet mode )
$def s-kflag  3 ( silent because of K flag )
$def s-silent 4 ( full silent mode )
 
( look-what values )
$def w-main   1 ( main desc )
$def w-succ   2 ( succ/fail )
$def w-co     3 ( _/co prop )
$def w-chead  4 ( contents header )
$def w-citem  5 ( contents item )
$def w-room   6 ( room name )
$def w-end   99
 
var sticky?
var cmd-wizlook
var look-what
$ifdef filter-support
var filter
$endif
var sublook ( look called as subprogram )
lvar subview-room
lvar subview-main
lvar subview-succ
var subview-contents
$ifdef neonet-support
$def dbg-sendpacket sendpacket pop
lvar neouser
lvar neoview
$endif
$ifdef cmd-path
lvar look-target
$endif
 
$define callable-program?
   dup ok? if
$ifdef look-call-not-wiz
    dup program? swap "L" flag? and
$else
    program?
$endif
   else pop 0 then
$enddef
 
lvar stack-depth
: safe-call ( s d -- s )
   depth 1 - stack-depth !
   trigger @ fake? if
$ifdef j-lib-fake
    dup "fake_ok" getpropstr dup if "y*" smatch then if
     fake-dbref @ fake-name @ fake_object trigger !
    else
     fake-dbref @ trigger !
    then
$else
    fake-dbref @ trigger !
$endif
    look-call call #-4 trigger !
   else
$ifdef cmd-path
    dup cmd-path dbcmp if
     look-target @ command !
     look-call call
     "look" command !
    else
$endif
     look-call call ( indirect call via wizbitted subroutine )
   then $ifdef cmd-path then $endif
   begin depth stack-depth @ = not while
    depth stack-depth @ < if "" else swap pop then
   repeat
   dup string? not if pop "" then
;
  
: simple-match ( s -- d 1 or 0 )
    striptail dup not if pop me @ 1 exit then
    dup "#*" smatch if .atodbref else match then
    dup ok? not if pop not-here error-tell 0 exit then
    me @ over controls not if pop perm-denied error-tell 0 exit then
    1
;
 
$ifdef filter-support
lvar save-filter
lvar save-trigger
: filter-tell ( s -- i )
   look-what @ swap
   filter @
   begin dup while
    " " .split save-filter !
    atoi dbref
    look-what @ w-citem = if
     trigger @ save-trigger ! 4 pick trigger !
     safe-call
     save-trigger @ trigger !
    else
     safe-call
    then
    save-filter @
   repeat pop
   dup if .atell else pop then
;
 
$define filter-end
   w-end look-what !
   begin "" filter-tell 99 = until
$enddef
  
lvar filter-head
: process-filters-sub
   " " explode
   begin dup while
    1 - swap
    dup "%*" smatch if
     dup 1 strcut swap pop prog "_reg/look-filter/" rot strcat getprop
     dup callable-program? if
      dup "order" getpropstr atoi
      "" filter-head !
      begin
       filter @ not if break then
       filter @ " " .split
       over atoi dbref "order" getpropstr atoi
       4 pick over over < if pop pop
        filter ! filter-head @ " " strcat swap strcat striplead filter-head !
       else = if
        filter ! pop break
       else
        pop pop break
       then then
      0 until
      pop
      filter-head @ " " strcat over intostr strcat rot strcat " " strcat
      filter @ strcat striplead filter !
     else pop then
    then
    pop
   repeat
   pop
;
 
: process-filters
   "" filter !
   "no_filter" wizlook? if exit then
   loc @ "_prefs/look/filter" envpropstr swap pop " " strcat
   me @ "_prefs/look/filter" getpropstr strcat
   strip dup not if pop exit then
   process-filters-sub
;
 
: install-filter ( d s -- )
   prog "_reg/look-filter/" 3 pick strcat getprop
   callable-program? if
    over "_prefs/look/filter" over over getpropstr
    " %" 5 rotate strcat strcat striplead setprop
    dup me @ dbcmp if pop filter-installed else
     room-filter-installed swap \name "%name" subst
    then
    msg-tell
   else
    pop pop no-such-filter error-tell
   then
;
 
: filter-info-sub
   strip dup if "" filter ! process-filters-sub filter @ then
   dup if
    begin dup while
     dup "%" instr strcut swap pop
     dup " " instr strcut rot rot strcat swap
    repeat pop striptail
   else pop "NONE" strcat then
   .tell
;
 
: filter-info
   "Available look filters:" .tell " " .tell
   prog "_reg/look-filter/" begin nextprop dup while
    prog over getprop dup callable-program? if
     over dup "/" rinstr strcut swap pop
     " -- " strcat swap "info" getpropstr
     strcat "  " swap strcat .tell
    else pop then
    prog swap
   repeat pop " " .tell
   "Installed filters: " me @ "_prefs/look/filter" getpropstr
   filter-info-sub
   "Filters in local environment: " loc @ "_prefs/look/filter" envpropstr swap pop
   filter-info-sub
;
 
: filter-actions
   dup "#filter *" smatch if
    8 strcut swap pop striplead
    dup "=" instr not if me @ swap install-filter exit then
    "=" .split swap simple-match
    if swap striplead install-filter else pop then exit
   then
   dup "#!filter" streq if pop "#!filter " then
   dup "#!filter *" smatch if
    9 strcut swap pop striplead
    simple-match if
     dup "_prefs/look/filter" remove_prop
     dup me @ dbcmp if pop filters-removed else
      room-filters-removed swap \name "%name" subst
     then
     msg-tell
    then exit
   then
   dup "#filter-info" smatch if pop
    prog "_reg/look-filter" propdir? if
     help-title
     filter-info
    else
     no-filters error-tell
    then exit
   then
   huh-message error-tell
;
$endif
 
: sublook-tell ( s -- )
$ifdef ansi-support
$ifdef neonet-support
   sublook @ 2 = if ansi_strip then
$endif
$endif
   look-what @
   dup w-main = if pop subview-main ! exit then
   dup w-succ = if pop subview-succ ! exit then
       w-room = if     subview-room ! exit then
   subview-contents @ dup if "\r" strcat then swap strcat subview-contents !
;
 
$ifdef colorized
$def unparseobj look-color "color-unparseobj" call
$else
$def item-color ( )
$endif
 
: tellname-sub ( <obj> name -- <obj> name )
   sticky? @ s-quiet > if item-color exit then
   over fake? if
    my-fake? if
     showfake fake-dark? @ if showdarkfake then
    else
     fake-dbref @ loc @ dbcmp if showfake then
    then
   else
    over me-controls if
     pop dup unparseobj exit
     over "D" flag? if over program? not if showdark then then
    else
     over "L" flag? if
      pop dup unparseobj exit
     else
      over player? not if over program? not if
       over dup "A" flag? swap "C" flag? or if
        pop dup unparseobj exit
       then
      then then
     then
    then
   then
   item-color
;
 
$def tellname tellname-sub .ntell
 
$def contents-loop fake.muf "contents_loop" call
 
$def contents-match fake.muf "contents_match" call
 
: reg-lookup swap pop match ; ( d s -- d )
 
lvar save-sticky?
lvar save-wizlook
lvar save-what
: prog-call ( @s -- s )
   1 strcut swap pop
   " " .split swap
   dup "$*" smatch if
    trigger @ swap reg-lookup
   else
    .atodbref
   then
   ( args prog -- )
   dup program? if
$ifdef look-call-not-wiz
    dup "L" flag? if
$else
    trigger @ owner over controls over "L" flag? or if
$endif
     sticky? @ save-sticky? !
     cmd-wizlook @ cmd-wizlook !
     look-what @ save-what !
$ifdef filter-support
     filter @ save-filter !
$endif
     safe-call
     save-sticky? @ sticky? !
     save-wizlook @ cmd-wizlook !
     save-what @ look-what !
$ifdef filter-support
     save-filter @ filter !
$endif
    else
     pop pop
     $ifdef look-call-not-wiz call-not-linkable $else call-perm-denied $endif
     error-tell ""
    then
   else
    pop pop call-not-program error-tell ""
   then
;
 
: execute-prop ( s d s s i -- s )
   4 pick 4 pick getpropstr if
    parseprop swap pop
    dup if
     dup "@[$0-9]*" smatch if
      prog-call
     then
    then
   else
    pop pop pop pop
   then
;
 
$def room-color $ifdef colorized "room" add-color $else ( ) $endif
 
: tellroomname ( d -- )
   w-room look-what !
   trigger @ "_/ro" envpropstr
   dup if
    "normal_room" wizlook? if pop 0 then
    me @ "_prefs/look/normal_room" getpropstr
    dup if "n*" smatch swap then pop
   then
   if
    swap pop "" swap "_/ro" "look" 1 execute-prop .iftell
   else
    pop sticky? @ s-silent = if \name room-color .ntell exit then
    dup me-controls if unparseobj .ntell exit then
    dup "L" flag? over "A" flag? or over "C" flag? or
$ifndef no-K-support
                                                      over "K" flag? or
$endif
    if unparseobj else \name room-color then .ntell
   then
;
 
: donotify ( d s d prop -- )
$ifdef masquerade
   ( no notifies in masquerade rooms )
   trigger @ location masquerade-room? if pop pop pop pop exit then
$endif
   over over getpropstr dup if
    dup "{n|no}" smatch not if
     "{y|ye|yes}" smatch if pop pop else
      rot pop "look" 1 parseprop
     then
     trigger @ name "%this" subst
     trigger @ location \name "%here" subst
$ifdef neonet-support
     sublook @ 2 = if neouser @ else over me @ far_pname then
$else
     over me @ far_pname
$endif
                "%name" subst
$ifdef neonet-support
     sublook @ 2 = if
      neouser @ "%n" subst
     then
$endif
     me @ swap pronoun_sub
     $ifdef ansi-support ansi_notify $else notify $endif exit
    then
   then
   pop pop pop pop pop
;
 
$ifdef look-long-support
lvar look-long
$endif
 
: look-desc ( s -- )
   w-main look-what !
   trigger @
   dup fake? if
( $ifdef look-long-support )
(   look-long @ if pop pop look-long-unset error-tell exit then )
( $endif )
    dup details? if
     pop details-prop "(@detail)"
    else
     owner get-notify-fake-msg
     "notify" fake-prop donotify
     "desc" fake-prop "(fakedesc)"
    then
$ifdef path-support
   else dup path? if pop
    prog-wiz? if
     fake-dbref @ "_tmp/" pid intostr strcat
     over over over fake-name @ pathdesc setprop
     rot 3 pick 3 pick fake-name @ 1 execute-prop
     .iftell remove_prop exit
    else
     fake-dbref @ dup fake-name @ pathdesc .iftell "(@Path)" 1 parsempi
     .iftell exit
    then
$endif
   else
    dup loc @ dbcmp dup if pop dup "_/ide" getpropstr then
    if "_/ide" "(@Idesc)" else "_/de" "(@Desc)" then
$ifdef look-long-support
    look-long @ if
     swap "lde" "de" subst swap
     4 rotate pop look-long-unset -4 rotate
    then
$endif
   then $ifdef path-support then $endif
   1 execute-prop .iftell
;
 
: look-remote-desc ( s -- )
   w-main look-what !
   trigger @
   dup fake? if 0 else dup "_remote_desc" getpropstr then if
    "_remote_desc" "(_remote_desc)" 1 execute-prop .iftell
   else
    pop look-desc
   then
;
 
: contents-tell ( s -- )
   trigger @ "_contents"
   over room? if envpropstr else getpropstr trigger @ swap then
   if "_contents" "(_contents)" 1 parseprop swap then
   pop $ifdef colorized "contents" add-color $endif .iftell
   w-citem look-what !
;
 
$ifdef fake-dark-objs-are-visible
: fake-visible? ( -- b )
   1 fake-is-dark? dup fake-dark? ! if
    pop sticky? @ if 0 else my-fake? then
   then
;
$endif
 
: look-contents-sub ( s b <obj> name -- s b <obj> )
$ifdef fake-dark-objs-are-visible
   over fake? if fake-visible? not if pop exit then then
$endif
   3 pick if 4 pick contents-tell rot pop 0 rot rot then
   over fake? if multi-1name then tellname
;
 
: look-contents ( s -- )
   trigger @ "_/co"
   over room? if envpropstr else getpropstr trigger @ swap then
   dup if
    "normal_contents" wizlook? if pop 0 then
    me @ "_prefs/look/normal_contents" getpropstr
    dup if "n*" smatch swap then pop
   then
   if
    ( _/co found )
    w-co look-what !
    swap pop "" swap "_/co" "(@contents)" 1 execute-prop .iftell
   else pop
    w-chead look-what !
    1 trigger @ 'look-contents-sub contents-loop pop pop
   then
;
 
$ifdef default-succ
lvar save-succ
$endif
: roomlock ( -- )
   w-succ look-what !
   "ignore_locks" wizlook? if 0 else me @ trigger @ locked? then if
    "" trigger @ "_/fl" "(@Fail)" 1 execute-prop
    $ifdef colorized "error" add-color $endif .iftell
    "" trigger @ "_/ofl" "(@Ofail)" 0 execute-prop .notell
   else
$ifdef default-succ
    trigger @ "_/sc" getpropstr dup save-succ ! not if
     trigger @ "_/sc" default-succ setprop
    then
$endif
    "" trigger @ "_/sc" "(@Succ)" 1 execute-prop
    $ifdef colorized "exits" add-color $endif .iftell
$ifdef default-succ
    save-succ @ not if trigger @ "_/sc" remove_prop then
$endif
    "" trigger @ "_/osc" "(@Osucc)" 0 execute-prop .notell
   then
;
 
$ifdef auto-notify
: notify-self
   trigger @ notify-self-msg
   over notify-prop donotify
;
 
: notify-owner
   trigger @ owner get-notify-owner-msg
   trigger @ notify-prop donotify
;
 
: notify-room
   trigger @ owner get-notify-room-msg
   trigger @ notify-prop envpropstr
   if notify-prop donotify else pop pop pop then
;
 
$ifdef look-long-support
: notify-long-self-or-owner
   trigger @ dup person? if
    notify-long-self-msg
   else
    owner notify-long-owner-msg
   then
   trigger @ notify-long-prop donotify
;
 
: notify-long-room
   trigger @ owner notify-long-room-msg
   trigger @ notify-long-prop envpropstr
   if notify-long-prop donotify else pop pop pop then
;
$endif
$else
$def notify-self ( )
$def notify-owner ( )
$def notify-room ( )
$ifdef look-long-support
$def notify-long-self-or-owner ( )
$def notify-long-room ( )
$endif
$endif
 
: look-room ( -- )
   trigger @ tellroomname
   "" look-desc
$ifdef look-long-support
   look-long @ if notify-long-room exit then
$endif
   roomlock
   loc @ me @ \location dbcmp if ( don't show contents if banished )
$ifndef no-Q-support
    trigger @ "Q" flag? not "ignore_Q" wizlook? or if
     "Contents:" look-contents
    then
$else
     "Contents:" look-contents
$endif
   then
   notify-room
$ifdef filter-support
   filter @ if filter-end then
$endif
;
 
: follow-exit? ( d -- d b )
   dup getlink dup #-3 dbcmp if pop me @ getlink then
   dup ok? not if pop 0 exit then
   over owner over controls if
    swap pop 1
   else
    pop 0
   then
;
 
: dolook ( b -- )
$ifdef filter-support
   process-filters
$endif
   trigger @ dup exit? if
    dup "_transparent?" getpropstr if
     follow-exit?
     if "" look-desc dup trigger ! then
    then
   then
   room? if pop look-room exit then
   nothing-special swap
$ifdef look-long-support
   look-long @ if
    pop
    trigger @ fake? $ifdef path-support trigger @ path? or $endif if
     pop pop look-long-no-fake error-tell exit
    else
     look-desc notify-long-self-or-owner exit
    then
   then
$endif
   if look-remote-desc else look-desc then
   trigger @ dup fake? $ifdef path-support over path? or $endif if pop else
    dup person? if
     pop "Carrying:" look-contents
     notify-self
    else
     "H" flag? not if "Contains:" look-contents then
     notify-owner
    then
   then
$ifdef filter-support
   filter @ if filter-end then
$endif
;
 
$def match-trigger fake.muf "match_trigger" call
 
: remote-look ( d -- b )
   dup details? if pop 1 exit then ( _details always visible )
   dup fake? if 0 else dup "_remote_look?" getpropstr then
   dup if swap pop else pop location "_remote_look?" getpropstr then
   dup if "n*" smatch if 0 else 1 then else pop 1 then
;
 
: do-lookat ( s s -- )
   dup strip not if pop pop huh-message error-tell exit then
   swap dup strip not if pop pop huh-message error-tell exit then
   match-trigger not if error-tell pop exit then ( match container )
   trigger @ dup room? if
    me-wiz? not if ( only Wizards can do lookat into a room )
     pop pop not-clear error-tell exit
    then
   then
   dup exit? if
    dup "_transparent?" getpropstr "window" streq
    if follow-exit? if dup trigger ! then then
   then
   dup exit? if
    pop pop not-window error-tell exit
   then
   #-1 0 contents-match pop swap pop
   ( d -- )
   dup #-1 dbcmp if pop not-there error-tell exit then
   dup #-2 dbcmp if pop ambiguous error-tell exit then
 ( dup #-3 dbcmp if pop not-there error-tell exit then )
   dup trigger ! remote-look if 1 dolook else
    not-clear error-tell
   then
;
 
lvar cmd-lookat
: lookat ( s -- b )
   dup "=" instr if "=" .split striplead swap striptail swap do-lookat 1 exit then
   dup "'s " instring if "'s " isplit striplead do-lookat 1 exit then
   dup " at " instring if " at " isplit do-lookat 1 exit then
   cmd-lookat @ if
    dup " " instr if " " .split striplead swap striptail swap do-lookat 1 exit then
   then
   pop 0
;
 
$ifdef neonet-support
$def temp-prop strcat prog "neo/" rot strcat
lvar cmd-neolook
 
: neonet-look ( s -- b )
   dup "@" instr 1 <= if pop 0 exit then
   "@" .split dup mucklive not if
   cmd-neolook @ if
    not-on-neonet swap "%muck" subst error-tell pop 1 exit
   else
    pop pop 0 exit
   then
   then
   me @ player? not if
    pop pop no-puppets error-tell 1 exit
   then
   netlive not if pop pop neonet-down error-tell 1 exit then
   background
   over "me" streq if swap pop me @ \name swap then
   over over netpmatch
   dup 0 < if pop
    user-not-found rot "%name" subst swap "%muck" subst error-tell 1 exit
   then
   send-request msg-tell
   pid intostr "/who" temp-prop me @ setprop
   "muck." 3 pick strcat ".look.request." strcat pid intostr strcat
   me @ \name " " strcat rot intostr strcat dbg-sendpacket
   180 sleep
   pid intostr "/who" temp-prop getprop if
    no-response over "%muck" subst error-tell
    300 sleep pid intostr "" temp-prop remove_prop
   then
   pop pop 1
;
 
lvar src-pid
: hookpacket ( type muck data -- )
   rot dup "." rinstr 1 - strcut 1 strcut src-pid ! pop
   dup "." rinstr strcut swap pop
   dup "request" streq if pop
    " " .split .atodbref
    ( src-muck src-user tgt )
    swap "@" strcat 3 pick strcat neouser !
    "[" over \name strcat "@" strcat nodename strcat "]" strcat neoview !
    dup "_prefs/look/neolook" getpropstr dup dup if "y*" smatch then if pop
     s-silent sticky? ! 2 sublook ! 0 cmd-wizlook !
$ifdef filter-support
     0 filter !
$endif
     "$lib/neonet" match "_player" getprop me ! #0 loc !
     "" subview-main ! "" subview-contents ! "" subview-room ! "" subview-succ !
     $ifdef colorized 1 40 variable ! $endif ( set no-color )
     trigger ! 0 dolook
     subview-main @ if
      neoview @ "\r" strcat subview-main @ strcat neoview !
     then
     subview-contents @ if
      neoview @ "\r" strcat subview-contents @ strcat neoview !
     then
    else
     neoview @ "\r" strcat neolook-perm-denied strcat neoview !
     if pop else
      dup "+++ " neouser @ strcat " just tried to look at you remotely (through the Neonet)" strcat notify 
      dup "+++ to set yourself visible to remote look: @set me=_prefs/look/neolook:yes" notify
          "+++ if you don't wish to be seen remotely:  @set me=_prefs/look/neolook:no" notify
     then
    then
    "muck." swap strcat ".look.response." strcat src-pid @ strcat
    neoview @ "{nl}" "\r" subst
    ( send in 800-byte chunks )
    begin dup while
     800 strcut 3 pick rot
     3 pick if "+" strcat else " " strcat then
     dbg-sendpacket
    repeat pop pop exit
   then
   dup "response" streq if pop
    dup strlen 1 - strcut dup "+" strcmp if strcat striptail else pop
     ( re-assemble )
     src-pid @ "/val" temp-prop over over getpropstr 4 rotate strcat setprop
     pop exit
    then
    src-pid @ "/who" temp-prop getprop dup not if pop pop pop exit then
    dup player? not if pop pop else
     src-pid @ "/val" temp-prop getpropstr
     rot strcat "\r" "{nl}" subst notify
    then
    src-pid @ "" temp-prop remove_prop
    pop exit
   then
   ( Error! )
   pop pop pop
;
$endif
 
$def look-ad "Get cmd-look for your Muck (Fuzzball or GlowMuck) from Jaffa's MUF Library:\rhttp://go.to/muf"
 
$def YES "YES" $ifdef colorized "message" add-color $endif
$def NO "no"
 
: check-version
   "Jaffa's " look-version strcat msg-tell
   fake.muf call msg-tell fake.muf-version strcmp if
    "WARNING: wrong version of fake.muf found." error-tell
   then
   " " .tell "Configuration options:" .tell
   "Fake objects visible by default: "
   $ifdef fake-show-default-is-no NO $else YES $endif strcat .atell
   "Hidden fake objects truely invisible: "
   $ifdef fake-dark-objs-are-visible NO $else YES $endif strcat .atell
   "ANSI color support enabled: "
   $ifdef ansi-support YES $else NO $endif strcat .atell
$ifdef ansi-support
   "Look output colorized: "
   $ifdef colorized YES $else NO $endif strcat .atell
$endif
   "Filter support enabled: "
   $ifdef filter-support YES $else NO $endif strcat .atell
   "Look notify enabled: "
   $ifdef auto-notify YES $else NO $endif strcat .atell
   "Default @succ message: "
   $ifdef default-succ default-succ $else NO $endif strcat .atell
   "Support K flag on rooms: "
   $ifdef no-K-support NO $else YES $endif strcat .atell
   "Support Q flag on rooms: "
   $ifdef no-Q-support NO $else YES $endif strcat .atell
   "Look #long supported: "
   $ifdef look-long-support YES $else NO $endif strcat .atell
   "Author flag supported: "
   $ifdef Author-support YES $else NO $endif strcat .atell
   "Remote look via Neonet: "
   $ifdef neonet-support YES $else NO $endif strcat .atell
   "@paths supported: "
   $ifdef path-support YES $else
    $ifdef cmd-path YES $else NO $endif
   $endif strcat .atell
   " ".tell
   me @ "$lib/look-install" match owner dbcmp if
    "Run $lib/look-install to change any of these settings." .tell
   else
    "Jaffa" .pmatch dup if dup "_prefs/look/ad" getpropstr else 0 then
    if "_prefs/look/ad" "look" 1 parseprop else pop look-ad then
    dup if .atell else pop then
   then
;
 
$def sh-yes dup "+*" smatch if 2 strcut swap pop else pop "" then
$def sh-no dup "-*" smatch if 2 strcut swap pop else pop "" then
 
: show-more-help
   look-messages LMGR-getlist begin dup while
    dup 1 + rotate
    dup "[+-]Q*" smatch if $ifdef no-Q-support sh-no $else sh-yes $endif else
    dup "[+-]K*" smatch if $ifdef no-K-support sh-no $else sh-yes $endif else
    dup "[+-]A*" smatch if $ifdef ansi-support sh-yes $else sh-no $endif else
    dup "[+-]C*" smatch if $ifdef colorized sh-yes $else sh-no $endif else
    dup "[+-]F*" smatch if $ifdef filter-support sh-yes $else sh-no $endif else
    dup "[+-]U*" smatch if $ifdef Author-support sh-yes $else sh-no $endif else
    dup "[+-]O*" smatch if $ifdef neonet-support sh-yes $else sh-no $endif else
    dup "[+-]L*" smatch if $ifdef look-long-support sh-yes $else sh-no $endif else
    dup "[+-]N*" smatch if $ifdef auto-notify sh-yes $else sh-no $endif else
    dup "[+-]G*" smatch if $ifdef Glow-unparseobj sh-yes $else sh-no $endif else
    dup "[+-]Z*" smatch if
     $ifdef fake-dark-objs-are-visible sh-no $else sh-yes $endif
    else
    dup "[+-]@*" smatch if
     trig \name "lookat" instr if sh-yes else sh-no then
    then then then then then then then then then then then then
    .tell 1 -
   repeat pop
;
 
$def show-help help-title show-more-help
 
$def wizlook-help "help/wizlook" show-more-help
 
lvar old-command
: look-help
   help-title
$ifdef neonet-support
   cmd-neolook @ if
    "Usage: " old-command @ strcat " <user>@<muck>" strcat .tell exit
   then
$endif
   me-wiz? old-command @ "w*" smatch and if wizlook-help exit then
   "help/main" show-more-help
;
 
$def look-help-filters $ifdef filter-support "help/filters" show-help $else no-filter-support error-tell $endif
 
$def look-help-long $ifdef look-long-support "help/long" show-help $else no-long-support error-tell $endif
 
$def look-help-neonet $ifdef neonet-support "help/neonet" show-help $else no-neonet-support error-tell $endif
 
$define look-help-ansi
$ifdef ansi-support
   "help/ansi" $ifdef __glowver "-glow" strcat $endif show-help
$else
   no-ansi-support error-tell
$endif
$enddef
 
$ifdef colorized
$def look-help-color "help/color" show-help
$def look-help-color2 "help/color2" show-help
$endif
 
$def look-help-index "help/index" show-help
$def look-help-silent "help/silent" show-help
$def look-help-fake "help/fake" show-help
$def look-help-contents "help/contents" show-help
$def look-help-exits "help/exits" show-help
$def look-help-lookat "help/lookat" show-help
$def look-help-props "help/props" show-help
 
: look-help-history
   help-title
   "history" prog LMGR-getlist 2 -
   begin dup while
    dup 1 + rotate .tell 1 -
   repeat pop pop pop
;
 
: look-help-notify
$ifdef auto-notify
   "help/notify" show-help " " .tell
   "    @set me=" notify-prop strcat ":yes" strcat .tell
   "               -- set yourself to be notified when you are looked at" .tell
   "    @set me=" notify-prop strcat ":<message>" strcat .tell
   "               -- set yourself to be notified with a custom message" .tell
$ifdef look-long-support
   "    @set me=" notify-long-prop strcat ":yes or <message>" strcat .tell
   "               -- set yourself to be notified for look #long" .tell
$endif
   "    @set <room or object>=" notify-prop strcat ":yes or <message>" strcat .tell
   "               -- you will be notified when the room or object is looked at" .tell
$ifdef look-long-support
   "    @set <room or object>=" notify-long-prop strcat ":yes or <message>" strcat .tell
   "               -- you will be notified when look #long is used" .tell
$endif
  "help/notify2" show-more-help
$else
   no-auto-notify error-tell
$endif
;
 
: look-help-topic
   dup not over "index" streq or if look-help-index exit then
   dup "filter*" smatch if pop look-help-filters exit then
   dup "long" streq if pop look-help-long exit then
   dup "ansi" streq if pop look-help-ansi exit then
$ifdef colorized
   dup "color" streq if pop look-help-color exit then
   dup "color2" streq if pop look-help-color2 exit then
$endif
   dup "silent" streq if pop look-help-silent exit then
   dup "fake" streq if pop look-help-fake exit then
   dup "contents" streq if pop look-help-contents exit then
   dup "exit*" smatch if pop look-help-exits exit then
   dup "notify" streq if pop look-help-notify exit then
   dup "lookat" streq if pop look-help-lookat exit then
   dup "neonet" streq if pop look-help-neonet exit then
   dup "props" streq if pop look-help-props exit then
   dup "history" streq if pop look-help-history exit then
   pop no-such-topic error-tell exit
;
 
( Callable interface to cmd-look for Wizbitted programs )
 
( Usage:
(   $include $lib/look-install
(        :
(   <looker> me ! <lookee> cmd-look "look" call
 
( Returns on stack:
(   <room name - "" if not a room>   (top of stack)
(   <main desc>
(   <@succ string>
(   <contents string> )
  
: look ( d -- s s s s )
   me @ location loc !
   s-silent sticky? ! 1 sublook ! 0 cmd-wizlook !
$ifdef filter-support
   0 filter !
$endif
   "" subview-main ! "" subview-contents ! "" subview-room ! "" subview-succ !
   $ifdef colorized color-init $endif
   trigger ! 0 dolook
   subview-contents @ subview-succ @ subview-main @ subview-room @
;
 
: main
   prog-wiz? if preempt then ( run in preempt mode if Wiz-bitted )
   $ifdef colorized color-init $endif
   command @ dup old-command !
   me-wiz? dup if pop
    dup "w*" smatch
    me @ "_prefs/wizlook/always_on" getpropstr dup if "y*" smatch then
    or
   then cmd-wizlook !
   ( command @ ) dup "n*" smatch "noisy" wizlook? or if s-noisy else
    me @ "_prefs/look/silent" envpropstr swap pop dup if "y*" smatch then
    me @ "S" flag? or if s-silent else 
$ifndef no-K-support
     loc @ "K" flag? if s-kflag else s-noisy then
$else
     s-noisy
$endif
    then
    dup not if pop
     me @ "_prefs/look/silent" getpropstr dup if
      dup "q*" smatch if pop s-quiet else "f*" smatch
       ( if s-fake else s-noisy then )
      then
     else pop s-noisy then
    then
   then sticky? !
   ( command @ ) "at" instring cmd-lookat ! "look" command !
$ifdef look-long-support
   0 look-long !
$endif
   0 sublook !
$ifdef neonet-support
   trig "neolook" getpropstr cmd-neolook !
$endif
   striplead
$ifdef cmd-path
   dup look-target !
$endif
   dup not if
    cmd-lookat @ if
     pop lookat-what error-tell exit
    then
$ifdef neonet-support
    cmd-neolook @ if pop look-help exit else pop "here" then
$else
    pop "here"
$endif
   else
    dup "#" 1 strncmp not if
     dup "#help" streq if pop look-help exit then
     dup "#help *" smatch if 6 strcut swap pop strip look-help-topic exit then
     dup "#version" streq if pop check-version exit then
$ifdef filter-support
     dup "#filter*" smatch if filter-actions exit then
     dup "#!filter*" smatch if filter-actions exit then
$endif
     dup "#edit" streq if pop "#edit here" then
     dup "#edit *" smatch if
      "$fakeobjecteditor" match dup callable-program? if
       "look #edit" command !
       swap 6 strcut swap pop swap look-call call
      else
       pop pop no-editor error-tell
      then exit
     then
     dup "#add" streq if
      pop add-usage error-tell exit
     then
     dup "#add *" smatch if
      "$fakeobjecteditor" match dup callable-program? if
       "look #add" command !
       look-call call
      else
       pop pop no-editor error-tell
      then exit
     then
     dup "#silent" streq if pop
      me @ "_prefs/look/silent" "yes" setprop
      silent-enabled msg-tell exit
     then
     dup "#quiet" streq if pop "#silent=quiet" then
     dup "#silent=*" smatch if
      8 strcut swap pop
      dup "quiet" streq if pop
       me @ "_prefs/look/silent" "quiet" setprop
       quiet-enabled msg-tell exit
      then
      dup "noisy" streq if pop
       me @ "_prefs/look/silent" "noisy" setprop
       noisy-enabled msg-tell exit
      then
          "fake" streq if
       me @ "_prefs/look/silent" "fake" setprop
       silent-fake-enabled msg-tell exit
      then
      unknown-mode error-tell exit
     then
     dup "#!silent" streq over "#!quiet" streq or if pop
      me @ "_prefs/look/silent" remove_prop
      silent-default msg-tell exit
     then
$ifdef look-long-support
     dup striptail "#long" streq if pop "#long here" then
     dup "#long *" smatch if 6 strcut striplead 1 look-long ! then
$endif
     dup "#reset" streq if pop
      me @ "_prefs/look/silent" remove_prop
      me @ "_prefs/look/filter" remove_prop
      me @ "_prefs/look/neolook" remove_prop
      me @ "_prefs/look/colors" remove_prop
      me @ "_prefs/wizlook" remove_prop
      me @ "_prefs/look/normal_contents" remove_prop
      me @ "_prefs/look/normal_room" remove_prop
      "Done." msg-tell exit
     then
    then
    cmd-lookat @ if
     dup lookat if pop exit then
    then
   then
   dup match-trigger if
    pop 0 dolook
   else
    over lookat if pop pop exit then
$ifdef neonet-support
    over neonet-look if pop pop exit then
$endif
    error-tell pop
   then
;
 
PUBLIC look
$ifdef neonet-support
PUBLIC hookpacket
$endif

