(  l&c.MUF     by Gyroplast   09/25/98   !Birthday proggie! :)
()
(  This allows you to put a fur onna leash to drag him/her/hir  )
(  around... pretty obvious, isn't it?  )
()
(  Instructions:  )
()
(  1.  Create a leash.  )
(  2.  Create a collar.  )
(  3.  Create an action called 'leash;unleash' on the leash object, and link it to this program.  )
(  4.  @set <leash-object>=_ID:<whatever you want as an ID>  )
(  5.  @set <leash-object>=LEASH/_isleash?:yes  )
(  6.  @set <collar-object>=_ID:<same ID like the leash>  )
(  7.  @set <collar-object>=COLLAR/_iscollar?:yes  )
(  8.  Go find a victim to drag around...heehee  )
()
(  The collar must be in the inventory of the victim, like the leash  )
(  which has to be in the master's inventory.  )
(  Then use the 'leash <player name>' command to force the victim  )
(  to follow you, and the 'unleash' command to let him/her/hir go.)
()
(  Of course you can only use a collar and a leash with the SAME ID  )
(  together, watch upper- and lowercase!  )
()
(  You *may* set up the following properties on the OBJECTS to  )
(  customize the messages : )
()
(  Set these properties on the LEASH object:  )
()
(  leash/succ:<message master sees when putting someone onna leash>  )
(  leash/osucc:<msg the room sees when s.o. is put onna leash>  )
(  leash/fail:<msg master sees when unable to leash the victim>  )
(  leash/ofail:<msg others see when master can't leash the victim>  )
(  leash/drop:<msg master sees when dragging the victim to a new room>  )
(  leash/odrop:<msg others see when entering the room with a victim>  )
(  leash/unleash:<msg master sees when unleashing the victim>  )
( leash/ounleash:<msg others see when unleashing the victim>  )
()
(  And these on the COLLAR object:  )
()
(  collar/succ:<message victim sees when put onna leash>  )
(  collar/fail:<msg victim sees when master fails to leash>  )
(  collar/drop:<msg victim sees when dragged to a new room>  )
(  collar/unleash:<msg victim sees when unleashed>  )
()
(  NOTE: The proper name will be prepended to mesgs shown to others,  )
(        and you may use standard pronoun substitutions.  )
()
(  HAVE PHUN!  )
()
()
()
lvar colobj
lvar leaobj
lvar victim
: vdb
  me @ "leash/victim" getpropstr
  dup if
  atoi dbref victim ! then pop
;
: isleash
  "LEASH/_isleash?" getpropstr
  "yes" strcmp not
;
: iscollar
  "COLLAR/_iscollar?" getpropstr
  "yes" strcmp not
;
: leashdb
  me @ contents
  begin
  dup #-1 dbcmp if "You don't have a leash!" .tell 0 exit then
  dup isleash not if next continue then
  break
  repeat
  leaobj !
;
: showsucc
  leaobj @ "leash/succ" getpropstr
  dup not if pop victim @
  "You attach the leash to %n's collar. %S will follow you now."
  dup leaobj @ swap "LEASH/succ" swap 0 addprop
  else
  victim @ swap then
  victim @ swap
  pronoun_sub
  .tell
  leaobj @ "leash/osucc" getpropstr
  dup not if pop vdb
  me @ name " attaches the leash to %n's collar." strcat
  dup leaobj @ swap "LEASH/osucc" swap 0 addprop
  else
  victim @ swap then
  victim @
  swap
  pronoun_sub
  me @ location swap
  me @ swap victim @ swap 2 swap
  notify_exclude
  colobj @ "collar/succ" getpropstr
  dup not if pop me @
  "%N attaches the leash to your collar. You will follow %o now."
  dup colobj @ swap "COLLAR/succ" swap 0 addprop
  else
  me @ swap then
  pronoun_sub
  victim @ swap notify
;
: showfail
  leashdb
  leaobj @ "leash/fail" getpropstr
  dup not if pop dup
  "You try to attach the leash to %n's collar, but it doesn't work."
  dup leaobj @ swap "LEASH/fail" swap 0 addprop
  else
  vdb then
  over swap
  pronoun_sub
  .tell
  leaobj @ "leash/ofail" getpropstr
  dup not if pop vdb
  me @ name
" fails to attach the leash to %n's collar." strcat
  dup leaobj @ swap "LEASH/ofail" swap 0 addprop
  else
  vdb then
  over
  victim !
  pronoun_sub
  me @ location swap
  me @ swap vdb dup string? if victim @ then swap 2 swap
  notify_exclude
  colobj @ "collar/fail" getpropstr
  dup not if pop me @
  "%N tries to attach %p leash to your collar, but it doesn't work."
  dup colobj @ swap "COLLAR/fail" swap 0 addprop
  else
  me @ swap then
  pronoun_sub
  vdb dup string? if victim @ then swap notify
;
: showdrop
  leaobj @ "leash/drop" getpropstr
  dup not if pop vdb
  "%n follows your guidance."
  dup leaobj @ swap "LEASH/drop" swap 0 addprop
  else
  vdb swap then
  pronoun_sub
  .tell
  leaobj @ "leash/odrop" getpropstr
  dup not if pop vdb
  me @ name " walks in with %n put on a leash." strcat
  dup leaobj @ swap "LEASH/odrop" swap 0 addprop
  else
  vdb swap then
  pronoun_sub
  me @ location swap
  me @ swap vdb swap 2 swap
  notify_exclude
  colobj @ "collar/drop" getpropstr
  dup not if pop me @
  "You follow %n."
  dup colobj @ swap "COLLAR/drop" swap 0 addprop
  else
  me @ swap then
  pronoun_sub
  vdb swap notify
;
: collardb
  victim @ contents
  begin
  dup #-1 dbcmp if "This player doesn't wear a collar!" .tell 0 exit then
  dup iscollar not if next continue then
  break
  repeat
  colobj !
;
: showunleash
  leashdb
  leaobj @ "leash/unleash" getpropstr
  dup not if pop vdb
  "You remove the leash from %n's collar."
  dup leaobj @ swap "LEASH/unleash" swap 0 addprop
  then
  victim @ swap
  pronoun_sub
  .tell
  leaobj @ "leash/ounleash" getpropstr
  dup not if pop vdb
  me @ name " removes the leash from %n's collar." strcat
  dup leaobj @ swap "LEASH/ounleash" swap 0 addprop
  then
  victim @ swap
  pronoun_sub
  me @ location swap
  me @ swap victim @ swap 2 swap
  notify_exclude
  colobj @ "collar/unleash" getpropstr
  dup not if pop me @
  "%N removes the leash from your collar."
  dup colobj @ swap "COLLAR/unleash" swap 0 addprop
  else
  me @ swap then
  pronoun_sub
  victim @ swap notify
;
: getID (d -- s)
  "_ID" getpropstr
;
: collarcheck (d -- i)
  contents
  begin
  dup #-1 dbcmp if "This player doesn't wear a collar!" .tell 0 exit then
  dup iscollar not if next continue then
  break
  repeat
  dup colobj !
  pop
  me @ contents
  begin
  dup #-1 dbcmp if "You don't have a leash!" .tell 0 exit then
  dup isleash not if next continue then
  break
  repeat
  dup leaobj !
  getID dup not if "The leash has no ID!" .tell 0 exit then
  colobj @ getID dup not if "The collar has no ID!" .tell 0 exit then
  stringcmp
  not
;
: getvictim
  pop
  .pmatch
  dup #-1 dbcmp if "I don't see that player here!" .tell exit then
  dup #-2 dbcmp if "I'm not sure who exactly you mean!" .tell exit then
  dup collarcheck dup if
  swap
  dup victim !
  intostr
  me @ swap
  "leash/victim" swap 0 addprop
  showsucc
  then
  not if showfail then
;
: letgo
  pop
  .pmatch
  dup #-2 dbcmp if "I'm not sure who exactly you mean!" .tell exit then
  dup victim !
  intostr
  collardb
  me @ 
  "leash/victim" getpropstr
  strcmp
  not if me @ "leash/victim" remove_prop showunleash else "This player is not leashed by you!" .tell then
;
: follow (d -- )
  dup me @ location
  moveto
;
: dragto
  me @ "leash/victim" getpropstr
  dup if
  atoi dbref
  dup victim !
  dup collarcheck if follow then
  then
;
: main
  dup "Arrive" stringcmp not if dragto exit then
  command @
  dup "leash" strcmp not if getvictim exit else
  dup "unleash" strcmp not if letgo exit else
  then then
;

