( BlackJack.muf     by Gyroplast@FuzzyLogic  03/08/99
 
  BlackJack card game.
 
  SETUP:
    1. Create an object
    2. Create an action on that object
    3. Run <action> #setup to initialise the card deck.
       This is only needed once.
    4. Type game #help to get more info
 
  Have phun!
 
  This program is freeware, port it like crazy! :]
  I'd appreciate a short msg about where it is ported to, though.
  Do NOT alter the code unless it is absolutely necessary!
  Questions, flames, fanmail, money, underwear, plushies and bombs to:
    gyroplast@wtal.de
)
 
$def CompleteDeck "AcAsAhAdKcKsKhKdQcQsQhQdJcJsJhJdTcTsThTd9c9s9h9d8c8s8h8d7c7s7h7d"
$def MAXCARDS 5
$def ANTE 5
$def MAXANTE 500
$def DECK trig location
$def killstack BEGIN dup while 1 - swap pop REPEAT pop
 
lvar RemainingDeck
 
: getcard?  ( s -- b )
  DECK swap "_bj/" swap strcat "/getcard?" strcat getpropstr
;
 
: moved?  ( s -- b )
  DECK swap "_bj/" swap strcat "/moved" strcat getpropstr
;
 
: isOp?  ( s -- b )
  DECK swap "_bj/" swap strcat
  "/isop?" strcat getpropstr
;
 
: gotSpecial?  ( s -- i )
  DECK swap "_bj/" swap strcat
  "/hand" strcat getpropstr
  dup strlen 4 = not if pop 0 exit then
  2 strcut 1 strcut pop swap 1 strcut pop
  dup "A" strcmp not over "J" strcmp not OR not if
   pop pop 0 exit
  then
  swap
  dup "A" strcmp not over "J" strcmp not OR not if
   pop pop 0 exit
  then
  dup "J" strcmp not 3 pick "J" strcmp not AND if
   pop pop 0 exit
  then
  dup "A" strcmp not 3 pick "A" strcmp not AND if
   pop pop 2 exit
  then
  dup "J" strcmp not 3 pick "A" strcmp not AND if
   pop pop 1 exit
  then
  dup "A" strcmp not 3 pick "J" strcmp not AND if
   pop pop 1 exit
  then
;
 
: GetAllPlayers  (  -- sn ... s1 n )
  DECK "_bj/players" getpropstr
  " " explode
;
 
: EndRound?
  GetAllPlayers
  BEGIN
    dup while
    1 - swap
    getcard? if killstack 0 exit then
  REPEAT
  pop
  1
;
 
: GetValue  ( s -- i )
  DECK swap "_bj/" swap strcat "/value" strcat getpropstr atoi
;
 
: RefreshValue ( s s --  )
  over GetValue
  over CompleteDeck swap instr
  dup 8 < if      ( Its an ace )
   pop
   dup 11 + 22 < if 11 + else 1 + then
  else
  dup 16 < if pop 4 + else
    dup 24 < if pop 3 + else
     dup 32 < if pop 2 + else
      dup 40 < if pop 10 + else
       dup 48 < if pop 9 + else
        dup 56 < if pop 8 + else
         pop 7 +
  then then then then then then then
 
  swap pop
  swap "_bj/" swap strcat "/value" strcat swap
  DECK -3 rotate intostr 1 ADDPROP
;
 
: shuffle
  "Shuffling deck, please wait.." .tell
  CompleteDeck RemainingDeck ! ( New Deck )
  200
  BEGIN
    dup while
    random 20 % 2 + 2 *
    BEGIN
      RemainingDeck @ strlen over <= if pop break then
      RemainingDeck @ over
      strcut dup strlen 2 - strcut
      swap rot
      strcat strcat RemainingDeck !
      4 +
    REPEAT
    1 -
  REPEAT
;
 
: GiveCardsToPlayers  ( sn ... s1 n --  )
  BEGIN
    dup while
    1 - swap
    dup getcard? not if pop continue then
    "_bj/" over strcat "/hand" strcat DECK swap getpropstr
    RemainingDeck @ 2 strcut RemainingDeck !
    3 pick over RefreshValue
    strcat
    dup strlen MAXCARDS 2 * = if
      over "_bj/" swap strcat "/getcard?" strcat DECK swap
      remove_prop
    then
    swap "_bj/" swap strcat "/hand" strcat swap DECK -3 rotate 1 ADDPROP
  REPEAT
  pop
;
 
: trade_cards
  GetAllPlayers
  GiveCardsToPlayers
  GetAllPlayers
  GiveCardsToPlayers
;
 
: resetall
  DECK "_bj" remove_prop
;
 
: InitPlayer  ( s --  )
  DECK "_bj/players" getpropstr
  over strcat DECK swap "_bj/players" swap 1 ADDPROP
  DECK swap "_bj/" swap strcat
  over over "/hand" strcat remove_prop
  over over "/getcard?" strcat "yes" 1 ADDPROP
  over over "/value" strcat remove_prop
  over over "/moved" strcat remove_prop
  pop pop
;
 
: SetOperator  ( s --  )
  DECK swap "_bj/" swap strcat
  "/isop?" strcat "yes" 1 ADDPROP
;
 
: GetAnte (  -- i )
  DECK "_bj/ante" getpropstr atoi
;
 
: SetNewAnte  ( s --  )
  STRIP atoi
  dup 1 < if DECK "_bj/ante" ANTE intostr 1 ADDPROP else
  dup MAXANTE > if DECK "_bj/ante" ANTE intostr 1 ADDPROP else
  intostr DECK swap "_bj/ante" swap 1 ADDPROP
  then then
  "Ante set to " GetAnte intostr strcat " pennies." strcat .tell
;
 
: showhelp
  "HELP GOES HERE" .tell
;
 
: main
  STRIP
  dup "#help" stringpfx 1 = if pop showhelp exit then
  command @ "game" stringcmp not if
    dup "#reset" stringpfx 1 = if
     pop
     me @ intostr isop? not if
      "You are not allowed to reset the game!" .tell
     else
      resetall
      me @ intostr SetOperator
     then
     exit
    then
     
    dup "#stop" stringpfx 1 = if
     pop
     me @ intostr isop? not if
      "You are not allowed to stop the game!" .tell
     else
      resetall
     then
     exit
    then
    dup "#ante" stringpfx 1 = if
     dup " " instr strcut swap pop SetNewAnte exit
    then
   "Unknown Command. Check 'game #help'" .tell
  else
   "Unknown Command. Check 'game #help'" .tell
  then
;

