( spar-engine.muf     by Gyroplast  02/02/2001   v0.80
 
  ATTENTION! ATTENTION!
    This program is in Beta phase, porting IS EXPLICITLY NOT allowed!
 
  This is the actual program to which the attack actions are linked.
  It's task is to evaluate if a delivered blow strikes, and how much damage
  it effectively causes. It also controls experience/level gain.
 
  Installation of a new attack command [short version]:
    1. Create the @action with appropriate name[s]
    2. @link it to this program
    3. Set the following props on the action to customize:
        _mindam  -  Minimum amount of damage dealt when hit
        _maxdam  -  Maximum amount of damage dealt when hit
        _selfdam -  Amount of damage dealt to _attacker_ when attack fails
        _level   -  Required level before command becomes available
        _complex -  Relativ complexity of move. Directly affects gained
                    experience and chance to hit/fail. 1 = simple, 10 = WHOA!
  
        _asucc   -  Success message for attacker
        _vsucc   -  Success message for victim when hit
        _osucc   -  Success message for everyone else around
        _adodge  -  Message for attacker when attack is actively dodged
        _vdodge  -  Message for victim when successfully dodging the attack
        _ododge  -  Message for rest when attack is dodged
        _afail   -  Total attack failure message for attacker
        _vfail   -  Total attack failure message shown to victim
        _ofail   -  You get the idea..
 
  A frontend to create/edit moves should be available, as well as detailed
  docs about the program interna.
  
  Contact: gyroplast@gyroplast.com     http://www.mufarchive.com
)
$include $spar/spar-roster
 
VAR db
LVAR victim
 
( message retrieval functions )
: GetMessage ( [ s -- s ] - Retrieve and subst msg stored in property s )
  trig swap getpropstr
  "$$$" "%" subst
  "%" "$$$A" subst
  "%" "$$$a" subst
  me @ swap pronoun_sub
 
  "%" "$$$V" subst
  "%" "$$$v" subst
  victim @ swap pronoun_sub
;
 
: AttackSuccess? ( [  -- b ] - evaluate if victim is hit )
  random 3 % 1 -   ( For now, dummy routine )
;
 
: AttackFail ( [ d --  ] - Do all the necessary stuff when attack fails )
  ( display msg to attacker )
  me @ "_afail" GetMessage notify
  
  ( display msg to victim )
  victim @ "_vfail" GetMessage notify
  
  ( display msg to others )
  me @ location me @ victim @ 2 "_ofail" GetMessage notify_exclude
  
  ( hurt attacker )
;
 
: AttackDodged ( [  --  ] - Do all the necessary stuff when attack is dodged )
  ( display msg to attacker )
  me @ "_adodge" GetMessage notify
  
  ( display msg to victim )
  victim @ "_vdodge" GetMessage notify
  
  ( display msg to others )
  me @ location me @ victim @ 2 "_ododge" GetMessage notify_exclude
  ( give little exp to attacker )
  ( give little exp to victim )
;
 
: AttackHit ( [ d --  ] - Do all the necessary stuff when attack hits )
  ( display msg to attacker )
  me @ "_ahit" GetMessage notify
  
  ( display msg to victim )
  victim @ "_vhit" GetMessage notify
  
  ( display msg to others )
  me @ location me @ victim @ 2 "_ohit" GetMessage notify_exclude
  ( give exp to attacker )
  ( hurt victim )
;
 
: DoAttack ( [  --  ]  -  Perform the attack on victim )
  AttackSuccess?           ( -1 fail, 0 dodged, 1 hit )
  
  dup -1 = if
    pop AttackFail exit
  then
  dup not if
    pop AttackDodged
  else
    pop AttackHit
  then
;
 
: mane
  dup not if
    pop "Who do you want to attack?" .tell exit
  then
  .pmatch victim !
  db getdbobj if exit then
 
  me @ enrolled? not if
    "Sorry, you are not officially allowed to fight. Enroll first." .tell exit
  then
  me @ gethp 1 < if
    "You cannot attack in your current condition!" .tell exit
  then
 
  victim @ player? not if
    "I am not aware of a player with that name." .tell exit
  then
  victim @ enrolled? not if
    "Your target is not officially allowed to fight." .tell exit
  then
  victim @ gethp 1 < if
    "This person is already defeated." .tell exit
  then
 
  victim @ DoAttack
;
$echo "ATTENTION! This program is in Beta phase, porting IS EXPLICITLY NOT ALLOWED!"

